#include "Matrix.h"
#include "Bruch.h"
#include <complex>
#include <time.h>
#include <Windows.h>


using namespace std;

void fill(Matrix<float>& m);

int main()
{
	//Tests fr Konstruktoren
	//Initialisierung stehts mit Null
	Matrix<float>a,b(2),c(10),d(2,2),e(3,4),f(6,4),g(2,2),h(2,2),i(8,5),j(1,1),k(2,2),l(2,2),m,n(1,3),o(3,1),p,r,s(3,1),t(1,4);
	
	cout << "Test-Programm fr Klasse MatrixVector" << endl << endl ;
	cout << "Ausgabe der Matrizen - entsprechend gewaehlter Dimension - Initialisiert mit Null" << endl;
	cout << "Konstruktoren" << endl;
	cout << "a" << endl << a << endl;									//a keine Parametereingabe -> 3x3 Matrix wird erstellt!
	cout << "b" << endl << b << endl;									//b bergabe eines Parameters
	cout << "c" << endl << c << endl;									//c bergabe eines Parameters
				
	cout << "d" << endl << d << endl;									//d bergabe von zwei Parametern (symmetrisch)
	cout << "e" << endl << e << endl;									//e bergabe von zwei Parametern 
	cout << "f" << endl << f << endl;									//f bergabe von zwei Parametern
				
	cout << "**********************************" << endl;

	//getRows()
	cout << "getRows()" << endl;
	cout << "Anzahl der Zeilen von Matrix a = " << a.getRows() << endl;		//Rckgabe der Anzahl der Zeilen
	cout << "Anzahl der Zeilen von Matrix e = " << e.getRows() << endl;		//Rckgabe der Anzahl der Zeilen
	cout << "Anzahl der Zeilen von Matrix f = " << f.getRows() << endl;		//Rckgabe der Anzahl der Zeilen
	cout << "**********************************" << endl;

	//getColumns()
	cout << "getColumns" << endl;
	cout << "Anzahl der Spalten von Matrix a = " << a.getColumns() << endl;	//Rckgabe der Anzahl der Spalten
	cout << "Anzahl der Spalten von Matrix e = " << e.getColumns() << endl;	//Rckgabe der Anzahl der Spalten
	cout << "Anzahl der Spalten von Matrix f = " << f.getColumns() << endl;	//Rckgabe der Anzahl der Spalten
	cout << "**********************************" << endl;

	//size()
	cout << "size()" << endl;
	cout << "Groesse der Matrix a = " << a.size() << endl;	//Rckgabe der Gre der Matrix a
	cout << "Groesse der Matrix b = " << b.size() << endl;	//Rckgabe der Gre der Matrix a
	cout << "Groesse der Matrix c = " << c.size() << endl;	//Rckgabe der Gre der Matrix a
	cout << "**********************************" << endl;

	
	//setRows()
	cout << "setRows()" << endl;
	cout << "Anzahl der Zeilen von Matrix f = " << endl;	//Rckgabe der Anzahl der Zeilen
	cout << f.getRows()<< endl;
	cout << "neu:"  << endl;
	f.setRows(5);
	cout << "Anzahl der Zeilen von Matrix f ->neu = "  << endl;		//Rckgabe der Anzahl der Zeilen
	cout << f.getRows()<< endl;
	cout << "**********************************" << endl;

	//setColumns()
	cout << "set Columns()" << endl;
	cout << "Anzahl der Spalten von Matrix f = "  << endl;		//Rckgabe der Anzahl der Spalten
	cout << f.getColumns()<< endl;
	cout << "neu:" <<endl;
	f.setColumns(6);
	cout << "Anzahl der Spalten von Matrix f ->neu = " << endl;		//Rckgabe der Anzahl der Spalten
	cout << f.getColumns()<< endl; 
	cout << "**********************************" << endl;

	
	// >> Eingabe
	cout << ">>" << endl;
	cout << "einfache Eingabe" << endl;
	cout << "a" << endl << a << endl;				// einfache Eingabe
	cout << "Eingabe Matrix a(3x3):" << endl;
	cin >> a;
	cout << "a neu:" << endl << a << endl;
	
	cout << "mehrfache Eingabe" << endl;
	cout << "b" << endl << b << endl;				//mehrfache Eingabe
	cout << "d" << endl << d << endl;
	cout << "Eingabe Matrix b und d (je 2x2):" << endl;
	cin >> b >> d;
	cout << "b neu:" << endl << b << endl;
	cout << "d neu:" << endl << d << endl;
	cout << "**********************************" << endl;
	

	// << Ausgabe
	cout << "<<" << endl;
	cout << "a" << endl << a  << endl;						//einfache Ausgabe
	cout << "a und b" << endl << a  << endl << b << endl;	//mehrfache Ausgabe
	cout << "**********************************" << endl;


	//Indexoperatoren
	cout << "Indexoperatoren" << endl;
	cout << "a" << endl << a  << endl;
	a(2,2)=99/1;
	cout << "a(2,2)=99" << endl << "a neu:" << endl << a  << endl;
	cout << "**********************************" << endl;
	
	
	//getColumnElements
	cout << "getColumnElements" << endl;
	fill(e);
	cout << "e" << endl << e << endl; 
	e.getColumnElements(2);
	cout << s << endl;
	cout << "**********************************" << endl;
	
	//getRowElements
	cout << "getRowElements" << endl;
	cout << "e" << endl << e << endl;
	e.getRowElements(2),
	cout << t << endl;
	cout << "**********************************" << endl;
	
	
	cout << "g:" << endl << g  << "h:" << endl << h << endl;
	
	 
	//Vergleichsoperatoren
	cout << "Vergleichsoperatoren " << endl;
	if(g==h) 
		{cout << "g==h" << endl;}
	else 
		{cout << "g!=h" << endl;}
	if(g!=h) 
		{cout << "g!=h" << endl;}
	else 
		{cout << "g==h" << endl;}
	  

	
	cout << "**********************************" << endl;
	fill(i);
	cout << "i" << endl << i << endl;
	cout << "**********************************" << endl;
	
	
	//issquare()
	cout << "isSquare" << endl;
	cout << "wenn quadratisch: true, sonst false" << endl;
	cout << h.isSquare() <<  " -> h ist quadratisch" << endl;
	cout << i.isSquare() <<  " -> i ist nicht quadratisch" << endl;
	cout << "**********************************" << endl;
	
	
	//iszero()
	cout << "iszero" << endl;
	cout << "wenn Nullmatrix: true, sonst false" << endl;
	cout << h.isZero() <<  " -> h ist Nullmatrix" << endl;	
	cout << d.isZero() <<  " -> d ist keine Nullmatrix" << endl;
	cout << "**********************************" << endl;


	//isunit()
	cout << "isunit" << endl;
	cout << "wenn Einheitsmatrix: true, sonst false" << endl;
	j(1,1)=1;
	cout << j.isUnit() <<  " -> j ist Einheitsmatrix" << endl;	
	cout << d.isUnit() <<  " -> d ist keine Einheitsmatrix" << endl;
	cout << "**********************************" << endl;


	//isdiagonal()
	cout << "isdiagonal" << endl;
	cout << "wenn Diagonalmatrix: true, sonst false" << endl;
	k(1,1)=1;
	cout << k.isDiagonal() <<  " -> k ist Diagonalmatrix" << endl;	
	cout << d.isDiagonal() <<  " -> d ist keine Diagonalmatrix" << endl;
	cout << "**********************************" << endl;

	//isscalar()
	cout << "isscalar" << endl;
	cout << "wenn scalar: true, sonst false" << endl;
	k(1,1)=1;
	cout << k.isScalar() <<  " -> k ist kein Skalar" << endl;	
	cout << j.isScalar() <<  " -> j ist Skalar" << endl;
	cout << "**********************************" << endl;


	//isupper()
	cout << "isupper" << endl;
	cout << "wenn rechte/obere Dreiecksmatrix: true, sonst false" << endl;
	//fill(k);
	k(2,2)=1;
	k(1,2)=1;
	cout << k.isUpper()<<  " -> k ist rechte/obere Dreiecksmatrix " << endl;	
	cout << f.isUpper()<<  " -> f ist keine rechte/obere Dreiecksmatrix" << endl;
	cout << "**********************************" << endl;

	//islower()
	cout << "islower" << endl;
	cout << "wenn linke/untere Dreiecksmatrix: true, sonst false" << endl;
	//fill(l);
	l(2,1)=1;
	cout << l.isLower()<<  " -> l ist linke/untere Dreiecksmatrix " << endl;	
	cout << i.isLower()<<  " -> i ist keine linke/untere Dreiecksmatrix" << endl;
	cout << "**********************************" << endl;

	//istriangular()
	cout << "istriangular" << endl;
	cout << "wenn keine Dreiecksmatrix: 0 zurck" << endl;
	cout << "wenn obere Dreiecksmatrix: 1 zurck" << endl;
	cout << "wenn untere Dreiecksmatrix: 2 zurck" << endl;
	cout << "wenn obere und untere Dreiecksmatrix (Diagonalmatrix): 3 zurck" << endl;
	cout << k.isTriangular()<<  " -> k ist obere Dreiecksmatrix " << endl;	
	cout << l.isTriangular()<<  " -> l ist untere Dreiecksmatrix" << endl;
	cout << i.isTriangular()<<  " -> i ist keine Dreiecksmatrix" << endl;
	m(1,1)=1;
	m(2,2)=1;
	m(3,3)=1;
	cout << m.isTriangular()<<  " -> m ist eine Diagonalmatrix" << endl;
	cout << "**********************************" << endl;

	//isColumnVector()
	cout << "columnvector" << endl;
	cout << "Spaltenvektor: true, sonst false" << endl;
	cout << n.isColumnVector()<< " -> n ist kein Spaltenvektor" << endl;
	cout << o.isColumnVector()<< " -> o ist ein Spaltenvektor" << endl;
	cout << "**********************************" << endl;

	//isRowVector()
	cout << "rowvector" << endl;
	cout << "Zeilenvektor: true, sonst false" << endl;
	cout << n.isRowVector()<< " -> n ist ein Zeilenvektor" << endl;
	cout << o.isRowVector()<< " -> o ist kein Zeilenvektor" << endl;
	cout << "**********************************" << endl;

	
	//swapRow()
	cout << "swaprow" << endl;
	fill(p);
	cout << "p vorher:" << endl << p << endl;
	p.swapRow(2,3);
	cout << "p danach:" << endl << p << endl;
	cout << "**********************************" << endl;
	
	//swapColumn()
	cout << "swapcolumn" << endl;
	fill(p);
	cout << "p vorher:" << endl << p << endl;
	p.swapColumn(1,2);
	cout << "p danach:" << endl << p << endl;
	cout << "**********************************" << endl;

system("PAUSE");

    //Tests fr Fehlermeldungen
    cout<<"Tests fr Fehlermeldungen: "<<endl;
	try {Matrix<float> q(0,1);} catch (MatrixException ex) {ex.showMsg();}		//	100
	try {p.setRows(0);} catch (MatrixException ex) {ex.showMsg();}				//	101
	try {p.setColumns(0);} catch (MatrixException ex) {ex.showMsg();}			//	102
	//try {p.swapColumn(1,4);} catch (MatrixException ex) {ex.showMsg();}			//	103
	try {r=n;} catch (MatrixException ex) {ex.showMsg();}						//	104
	try {p.getRowElements(100);} catch (MatrixException ex) {ex.showMsg();}		//	105
	try {p.getColumnElements(100);} catch (MatrixException ex) {ex.showMsg();}	//	106
	
system("PAUSE");
}

	//	Fllt eine Matrix mit zuflligen Zahlen.
	void fill(Matrix<float>& m)
	{
		unsigned int rows = m.getRows();
		unsigned int columns = m.getColumns();
		srand((unsigned int)time(NULL));
		for (unsigned r=1; r<=rows; r++)
			for (unsigned c=1; c<=columns; c++)
				(m)(r,c) = (float)(rand() % 10);
		Sleep(1000);
	}




